   p=0.6
   lambda=1.5
   phi=0.6
   MCsz=50
   m=c(100,300,500,1000,5000)
                                       # define I(i=j)
   g<-function(a,b)
   {
       if(a==b)
       return(1)
       else 
       return(0)
   }

   marginal=function(p, lambda, x)           # Marginal distribution of ZIP(p,lambda)
   {
       if(x==0)
       return(1-p+p*exp(-lambda))
       else
       return(p*exp(-lambda)*lambda^x/factorial(x))
   } 

   aic_zipar=matrix(0,length(m),1)
   aic_peg=matrix(0,length(m),1)
   aic_inar=matrix(0,length(m),1)

   count_zipar=matrix(0,length(m),1)
   count_peg=matrix(0,length(m),1)
   count_inar=matrix(0,length(m),1)
   
   for(ii in 1:length(m))
   {
        count=0
        n=m[ii]
        for(tt in 1:MCsz)
        {
#            set.seed(ii+tt)   # Simulation of y[1].........y[n] ~ y_t = [phi, y[t-1] * (1-phi, e_t)
           y=NULL   
           y[1]=rpois(1,lambda)
   
           prob=NULL
           for(j in c(1:11))
              {
                 k=seq(0,10)
                 prob[j]=(exp(-lambda)*lambda^(j-1))/(factorial(j-1))
              }

           q=NULL
           for(i in 1:(n-1))
              {
                    for(j in c(1:11))
                       {
                            d=j-1
                            q[j]=phi*g(y[i],d)+(1-phi)*prob[j]
                        } 

                    y[i+1]=sample(0:10,1,replace=T,q)
               }

                                  # Simulation of z[1],z[2],....z[n] ~ z_t = x_t y_t
          z=NULL
          for(i in 1:n)
             {
                   x=rbinom(1,1,p)
                   z[i]=x*y[i]
              }
#---------------------------------------------# AIC of ZIPPAR(1) process
                    likelihood=function(x)
                    {
                                  phihat=x[1]
                                  lambdahat=x[2]
                                  phat=x[3]

                                  if(z[1]==0)
                                  f=log(1-phat+phat*exp(-lambdahat))
                                  else
                                  f=log(phat*exp(-lambdahat)*lambdahat^z[1]/factorial(z[1]))
                                  for(i in 1:(n-1))
                                  {
                                              if(z[i]==0 && z[i+1]==0)
                                              f=f+log(1-phat+phat*exp(-lambdahat)+{phat^2*phihat*exp(-lambdahat)*(1-exp(-lambdahat))}/{1-phat+phat*exp(-lambdahat)})
                                              else if(z[i]==0 && z[i+1]!=0)
                                              f=f+log(phat*{1-phat+phat*exp(-lambdahat)*(1-phihat)}*{exp(-lambdahat)*lambdahat^z[i+1]}/{{1-phat+phat*exp(-lambdahat)}*factorial(z[i+1])})
                                              else if(z[i]!=0 && z[i+1]==0)
                                              f=f+log(1-phat+phat*exp(-lambdahat)*(1-phihat))  
                                              else if(z[i]!=0 && z[i+1]!=0)
                                              f=f+log(phat*{phihat*g(z[i+1],z[i])+(1-phihat)*exp(-lambdahat)*lambdahat^z[i+1]/factorial(z[i+1])})
                                   }
                                   return(-f)
                    }
                    opt_zipar<-optim(fn=likelihood, lower=c(0.01,0.01,0.01), upper=c(0.99,5,0.99), par=c(0.5,4,0.5))
                    print(opt_zipar$par)
                    aic_zipar[ii]=2*likelihood(opt_zipar$par)+2*3
               
#---------------------------------------------# AIC of Pegram's AR(1) model

                likelihood<-function(x)
                {
                             phihat=x[1]
                             lambdahat=x[2]   
                             f=log(exp(-lambdahat)*lambdahat^z[1]/factorial(z[1]))  
                             for(i in c(1:(n-1)))            
                             f=f+log(phihat*g(z[i],z[i+1])+(1-phihat)*exp(-lambdahat)*lambdahat^z[i+1]/factorial(z[i+1]))          
                             return(-f)
                 }             
                 opt_peg<-optim(fn=likelihood,  lower=c(0.001,0.001), upper=c(0.999,5), par=c(0.5, 0.5))
                 aic_peg[ii]=2*likelihood(opt_peg$par)+2*2

#-------------------------------------------------# AIC of PINAR(1)
               likelihood<-function(x)
               {
                  alpha=x[1]
                  lambda=x[2]
                  f=log(exp(-lambda)*lambda^z[1]/factorial(z[1])) 
                  for(i in c(1:(n-1)))
                  {
                        j1<-seq(0,min(z[i],z[i+1]))
                        f<-f+log(sum((choose(z[i],j1)*(alpha)^j1*(1-alpha)^(z[i]-j1)*exp(-lambda*(1-alpha))*(lambda*(1-alpha))^(z[i+1]-j1))/factorial(z[i+1]-j1)))
                  }                
                  return(-f)
               }         
               opt_inar<-optim(fn=likelihood,  lower=c(0.001,0.001), upper=c(0.999,5), par=c(0.5, 0.5))
               aic_inar[ii]= 2*likelihood(opt_inar$par)+2*2 
               
               if(aic_zipar[ii]<aic_peg[ii] && aic_zipar[ii]<aic_inar[ii])  
               {
                     count_zipar[ii]=count_zipar[ii]+1
               }
               else if(aic_peg[ii]<aic_zipar[ii] && aic_peg[ii]<aic_inar[ii])
               {
                     count_peg[ii]=count_peg[ii]+1
               }
               else if(aic_inar[ii]<aic_peg[ii] && aic_inar[ii]<aic_zipar[ii])  
               {
                     count_inar[ii]=count_inar[ii]+1
               }             
               count=count+1
           }  
           aic_zipar[ii]=aic_zipar[ii]/count
           print(aic_zipar[ii])
           aic_peg[ii]=aic_peg[ii]/count
           print(aic_peg[ii])
           aic_inar[ii]=aic_inar[ii]/count 
           print(aic_inar[ii])   
           
           count_inar[ii]=count_inar[ii]/count * 100
           count_peg[ii]=count_peg[ii]/count * 100
           count_zipar[ii]=count_zipar[ii]/count * 100
   }

